<template>
  <v-card>
    <v-card-title>
      {{ title }}
    </v-card-title>
    <v-text-field
      label="Search"
      outlined
      clearable
      v-model="search"
      class="mx-3"
    ></v-text-field>
    <v-list>
      <v-list-item-group v-model="selected">
        <v-list-item v-for="element in elements" :key="element._id">
          <v-list-item-title>{{ element.name }}</v-list-item-title>
        </v-list-item>
      </v-list-item-group>
    </v-list>
    <v-card-actions>
      <v-btn :to="'/' + slug + '/add'">Ajouter</v-btn>
      <v-btn :to="'/' + slug + '/edit?id=' + selectedId" :disabled="disabled">Modifier</v-btn>
      <v-btn :disabled="disabled" @click="deleteElement">Supprimer</v-btn>
    </v-card-actions>
  </v-card>
</template>

<script>
import Vue from 'vue'

export default Vue.extend({
  props: {
    title: String,
    fetchedElements: Array,
    slug: String,
  },
  data() {
    return {
      selected: null,
      search: null,
    }
  },
  computed: {
    elements() {
      return this.fetchedElements.filter(e => !this.search || e.name.toLowerCase().includes(this.search.toLowerCase()))
    },
    disabled() {
      return this.selected !== 0 && !this.selected;
    },
    selectedId() {
      if (this.selected == null) return null;

      console.log(this.elements[this.selected]);
      return this.elements[this.selected]._id;
    }
  },
  methods: {
    deleteElement() {
      const id = this.selected._id;

      this.$axios.delete('/' + this.slug + '/' + id)
      .then(res => {
        if (res.code === 200) {
            this.$router.push('/');
        } else {
          console.log(res);
        }
      })
      .catch(err => {
        console.log(err);
      })
    },
  }
})
</script>
